package com.iamberry.wechat.tools;

import org.springframework.stereotype.Component;

import java.util.HashMap;

@Component
public class SendMessageUtil {
		
		//快递公司列表
		public static HashMap<String, String> hashmap = new HashMap<String, String>();
		//正式环境
		{
			hashmap.put("sto", "申通快递");
			hashmap.put("yto", "圆通快递");
			hashmap.put("sf", "顺丰快递");
			hashmap.put("longbanwuliu", "龙邦快递");
			hashmap.put("ems", "邮政EMS");
			hashmap.put("zto", "中通快递");
			hashmap.put("zjs", "宅急送");
			hashmap.put("yunda", "韵达快递");
			hashmap.put("cces", "cces快递");
			hashmap.put("pick", "上门提货");
			hashmap.put("htky", "汇通快递");
			hashmap.put("ttkdex", "天天快递");
			hashmap.put("stars", "邮政EMS");
			hashmap.put("jd", "星晨急便");
			hashmap.put("01", "其他");
			hashmap.put("02", "上门送货");
		}
		
		/**
		 * 发送模板通知给用户
		 * @param date data 日期
		 * @param openId 接受的用户id
		 * @param url  点击打开的url
		 * @param type 发送类型 1，订单审核结果通知 2，审核结果通知 3、商品入库通知,4、提货申请通知 5、申请单出库通知
		 * @return
		 */
		public boolean sendTemplateMessageToOpenid(String date,String openId, String url,Integer type) {
			boolean result = false;
			switch (type) {
			case 1:  //1，订单审核结果通知
				WeixinUtil.sendTemplateMessage(NameUtils.getConfig("appId"), NameUtils.getConfig("appSecret"), openId,ResultInfo.ORDER_REVIEW_RESULTS, date, url);
				break;
			case 2:  // 2，审核结果通知
				WeixinUtil.sendTemplateMessage(NameUtils.getConfig("appId"), NameUtils.getConfig("appSecret"), openId, ResultInfo.REVIEW_RESULTS, date, url);
				break;
			case 3:  //3、商品入库通知
				WeixinUtil.sendTemplateMessage(NameUtils.getConfig("appId"), NameUtils.getConfig("appSecret"), openId, ResultInfo.GOODS_WAREHOUSING_NOTICE, date, url);
				break;
			case 4:  //4、提货申请通知
				WeixinUtil.sendTemplateMessage(NameUtils.getConfig("appId"), NameUtils.getConfig("appSecret"), openId, ResultInfo.APPLICATION_DELIVERY_NOTIFICATION, date, url);
				break;
			case 5:  //5、申请单出库通知 (通过/驳回)
				WeixinUtil.sendTemplateMessage(NameUtils.getConfig("appId"), NameUtils.getConfig("appSecret"), openId, ResultInfo.DELIVERY_APPLICATION_FORM, date, url);
				break;
			default: 
				break;
			}
			result = true;
			return  result;
		}
		
		public static void main(String[] args) {
			String date = "{'first':{'color':'#173177', 'value':'尊敬的客户您好~您的订单已发货~'}, 'order_id':{'color':'#173177','value':'1009145345B11792L'}, 'package_id':{'color':'#173177','value':'yuantong:34234234'}, 'remark':{'color':'#173177', 'value':'点击进入商城查看-->>'}}";
			String openId = "o-icas0dRzE7WYAEAmcX4BQCUyFo";
			String appId = "wxd995fb95b97ece1b";// 应用ID
			String appSecret = "34922854462fba23cf54ce859349fcf4";// 应用密钥
			
			WeixinUtil.sendTemplateMessage(appId, appSecret, openId, "744KA1PdB1I5PzRcjtxqbEz5t2bp8vdsi4I2ytW1rbE", date, "xx");
			System.out.println("发送成功");
		}
		
		/**
		 * 订单审核结果推送
		 * @param first  标题
		 * @param keyword1	订单号
		 * @param keyword2	申请人姓名
		 * @param keyword3	申请时间
		 * @param keyword4	详细资料
		 * @param remark	全部内容
		 * @param openId	用户openid
		 * @param url	地址
		 */
		public void orderReviewResultsPush(String first,String keyword1,String keyword2,String keyword3,String keyword4,String remark,String openId,String url){
			String temp = ResultInfo.ORDERREVIEWRESULTS;
			temp = temp.replaceFirst("firstValueIamberry", first)
					.replaceFirst("keyword1Value",keyword1)
					.replaceFirst("keyword2Value",keyword2)
					.replaceFirst("keyword3Value",keyword3)
					.replaceFirst("keyword4Value",keyword4)
					.replaceFirst("remarkValue",remark);
				sendTemplateMessageToOpenid(temp, openId, url,1);
		}


	/**
	 * 审核结果通知推送
	 * @param first  标题
	 * @param keyword1	姓名
	 * @param keyword2	审核结果
	 * @param keyword3	审核时间
	 * @param remark	全部内容
	 * @param openId	用户openid
	 * @param url	地址
	 */
	public void reviewResultsPush(String first,String keyword1,String keyword2,String keyword3,String remark,String openId,String url){
		String temp = ResultInfo.REVIEWRESULTS;
		temp = temp.replaceFirst("firstValueIamberry", first)
				.replaceFirst("keyword1Value",keyword1)
				.replaceFirst("keyword2Value",keyword2)
				.replaceFirst("keyword3Value",keyword3)
				.replaceFirst("remarkValue",remark);
		sendTemplateMessageToOpenid(temp, openId, url,2);
	}

	/**
	 * 商品入库通知推送
	 * @param first
	 * @param keyword1	商品信息
	 * @param keyword2	入库数量
	 * @param keyword3	操作人员
	 * @param keyword4	入库仓库
	 * @param remark	全部内容
	 * @param openId	用户openid
	 * @param url	地址
	 */
	public void putStoragePush(String first,String keyword1,String keyword2,String keyword3,String keyword4,String remark,String openId,String url){
		String temp = ResultInfo.GOODSWAREHOUSINGNOTICE;
		temp = temp.replaceFirst("firstValueIamberry", first)
				.replaceFirst("keyword1Value",keyword1)
				.replaceFirst("keyword2Value",keyword2)
				.replaceFirst("keyword3Value",keyword3)
				.replaceFirst("keyword4Value",keyword4)
				.replaceFirst("remarkValue",remark);
		sendTemplateMessageToOpenid(temp, openId, url,3);
	}

	/**
	 * 提货申请通知推送
	 * @param first
	 * @param keyword1	报检单号
	 * @param keyword2	提货方
	 * @param keyword3	提货仓库
	 * @param keyword4	申请时间
	 * @param remark	全部内容
	 * @param openId	用户openid
	 * @param url	地址
	 */
	public void applicationDeliveryPush(String first,String keyword1,String keyword2,String keyword3,String keyword4,String remark,String openId,String url){
		String temp = ResultInfo.APPLICATIONDELIVERYNOTIFICATION;
		temp = temp.replaceFirst("firstValueIamberry", first)
				.replaceFirst("keyword1Value",keyword1)
				.replaceFirst("keyword2Value",keyword2)
				.replaceFirst("keyword3Value",keyword3)
				.replaceFirst("keyword4Value",keyword4)
				.replaceFirst("remarkValue",remark);
		sendTemplateMessageToOpenid(temp, openId, url,4);
	}


	/**
	 * 申请单出库通知推送
	 * @param first  标题
	 * @param keyword1	申请时间
	 * @param keyword2	申请单号
	 * @param keyword3	物料名称
	 * @param remark	全部内容
	 * @param openId	用户openid
	 * @param url	地址
	 */
	public void applicationFormPush(String first,String keyword1,String keyword2,String keyword3,String remark,String openId,String url){
		String temp = ResultInfo.DELIVERYAPPLICATIONFORM;
		temp = temp.replaceFirst("firstValueIamberry", first)
				.replaceFirst("keyword1Value",keyword1)
				.replaceFirst("keyword2Value",keyword2)
				.replaceFirst("keyword3Value",keyword3)
				.replaceFirst("remarkValue",remark);
		sendTemplateMessageToOpenid(temp, openId, url,5);
	}
}
